// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIFlexLayout;
import org.apache.myfaces.tobago.layout.AlignItems;
import org.apache.myfaces.tobago.layout.JustifyContent;
import org.apache.myfaces.tobago.layout.MeasureList;
import org.apache.myfaces.tobago.renderkit.css.CustomClass;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.component.Tags;
import javax.annotation.Generated;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders a &lt;a href=https://www.w3.org/TR/css-flexbox-1/&gt;Flexible Box Layout&lt;/a&gt;.
  * UIComponent class, generated from template {@code component.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.FlexLayoutTagDeclaration}.
 */
@Generated("component.stg")
public class UIFlexLayout
    extends AbstractUIFlexLayout implements ClientBehaviorHolder {

  public static final String COMPONENT_TYPE = Tags.flexLayout.componentType();

  public static final String COMPONENT_FAMILY = "org.apache.myfaces.tobago.FlexLayout";


  enum PropertyKeys {
    markup,
    alignItems,
    columns,
    customClass,
    rows,
    justifyContent,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  This value defines CSS align-items value of the flex layout.
  <br>Allowed Values: <code>flexStart,flexEnd,baseline,center,stretch</code>
  */
  public org.apache.myfaces.tobago.layout.AlignItems getAlignItems() {
    return (org.apache.myfaces.tobago.layout.AlignItems) getStateHelper().eval(PropertyKeys.alignItems);
  }

  public void setAlignItems(org.apache.myfaces.tobago.layout.AlignItems alignItems) {
    getStateHelper().put(PropertyKeys.alignItems, alignItems);
  }

  /**
  This value defines the layout constraints for column layout.
   It is a semicolon separated list of layout tokens '&lt;n&gt;*', '&lt;measure&gt;' or the keyword 'auto'.
   Where &lt;n&gt; is a positive integer or empty and &lt;measure&gt; is a valid CSS length.
   Example: '2*;*;100px;3rem;auto'.

  */
  public org.apache.myfaces.tobago.layout.MeasureList getColumns() {
    return (org.apache.myfaces.tobago.layout.MeasureList) getStateHelper().eval(PropertyKeys.columns);
  }

  public void setColumns(org.apache.myfaces.tobago.layout.MeasureList columns) {
    getStateHelper().put(PropertyKeys.columns, columns);
  }

  /**
  Sets a CSS class in its parent, if the parent supports it.

   Which this feature it is possible to put a CSS class name into a component with the &lt;tc:style&gt; tag. Example:

   <pre>
   &lt;tc:in&gt;
     &lt;tc:style customClass="my-emphasized"/&gt;
   &lt;/tc:in&gt;
   </pre>

   One capability is, to used external CSS libs.
   <br>
   This feature should not be used imprudent.
   Because it might be unstable against changes in the renderered HTML code.

  */
  public org.apache.myfaces.tobago.renderkit.css.CustomClass getCustomClass() {
    return (org.apache.myfaces.tobago.renderkit.css.CustomClass) getStateHelper().eval(PropertyKeys.customClass);
  }

  public void setCustomClass(org.apache.myfaces.tobago.renderkit.css.CustomClass customClass) {
    getStateHelper().put(PropertyKeys.customClass, customClass);
  }

  /**
  This value defines the layout constraints for row layout.
   It is a semicolon separated list of layout tokens '&lt;n&gt;*', '&lt;measure&gt;' or the keyword 'auto'.
   Where &lt;n&gt; is a positive integer or empty and &lt;measure&gt; is a valid CSS length.
   Example: '2*;*;100px;3rem;auto'.

  */
  public org.apache.myfaces.tobago.layout.MeasureList getRows() {
    return (org.apache.myfaces.tobago.layout.MeasureList) getStateHelper().eval(PropertyKeys.rows);
  }

  public void setRows(org.apache.myfaces.tobago.layout.MeasureList rows) {
    getStateHelper().put(PropertyKeys.rows, rows);
  }

  /**
  This value defines CSS justify-content value of the flex layout.
  <br>Allowed Values: <code>flexStart,flexEnd,center,spaceBetween,spaceAround</code>
  */
  public org.apache.myfaces.tobago.layout.JustifyContent getJustifyContent() {
    return (org.apache.myfaces.tobago.layout.JustifyContent) getStateHelper().eval(PropertyKeys.justifyContent);
  }

  public void setJustifyContent(org.apache.myfaces.tobago.layout.JustifyContent justifyContent) {
    getStateHelper().put(PropertyKeys.justifyContent, justifyContent);
  }


  @Override
  public void restoreState(FacesContext context, Object state) {
    // FIXME HACK for mojarra SystemEventListener state restoring bug
    pushComponentToEL(context, this);
    super.restoreState(context, state);
    popComponentFromEL(context);
  }

}